unit uScreen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DXDraws, DXClass, ExtCtrls, StdCtrls, AppEvnts, ComCtrls;

type
  TScreenForm = class(TForm)
    DXDraw: TDXDraw;
    DXTimer: TDXTimer;
    ApplicationEvents1: TApplicationEvents;
    btnStart: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    TrackBar1: TTrackBar;
    btnStop: TButton;
    DXDraw1: TDXDraw;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);
    procedure DXDrawMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DXDrawMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  protected
    procedure SetRegion;
    procedure SetSkin;
    procedure SetViewport(Handle:THandle;Bitmap:TBitmap);
  public
    { Public declarations }
  end;

var
  ScreenForm: TScreenForm;

implementation

uses uDatas, uUtility, uConst, uGlobal, uGoods;

{$R *.DFM}

procedure TScreenForm.SetRegion;
var region:THandle;
begin
  Height:=Datas.ImgSkin.Height;
  Width:=Datas.ImgSkin.Width;
  region:=CreateBitmapRgn(Datas.ImgSkin.Picture.Bitmap,clBlack);
  OffsetRgn(region,-1,12);
  SetWindowRgn(Handle,region,True);
  bDrawRegion:=True;
end;

procedure TScreenForm.SetSkin;
begin
  DXDraw.Surface.LoadFromGraphic(Datas.ImgSkin.Picture.Graphic);
end;

procedure TScreenForm.DXTimerTimer(Sender: TObject; LagCount: Integer);
begin
  SetSkin;
  LayoutThree.Move(0);
  LayoutTwo.Draw;
  LayoutThree.Draw;
  LayoutFour.Draw;
  LayoutFive.Draw;
  LayoutSix.Draw;
  LayoutSeven.Draw;
//  SetViewport(DXDraw.Surface.Canvas.handle,
//    Datas.imgViewport.Picture.Bitmap);
//  DXDraw.Surface.Draw(0,0,DXDraw1.Surface);
//  DXDraw.Primary.BltFast(0,0,Rect(0,0,200,200),0,DXDraw1.Surface);
//  BitBlt(DXDraw.Surface.Canvas.Handle,0,0,200,200,DxDraw1.Surface.Canvas.Handle,0,0,Srccopy);
//  DXDraw.Surface.Canvas.Release;
//  DXDraw1.Flip;
  DXDraw.Flip;
end;

procedure TScreenForm.DXDrawMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button=mbLeft) then
  begin
    if XYInMiniIcon(X,Y) then
    begin
      SetWindowRgn(Handle,0,True);
      Self.WindowState:=wsMinimized;
      bDrawRegion:=False;
      Application.Minimize;
      exit;
    end;
    if XYInCloseIcon(X,Y) then
    begin
      Close;
      exit;
    end;
    ReleaseCapture;
    SendMessage(Handle,WM_NCLBUTTONDOWN,HTCAPTION,0);
  end;
end;

procedure TScreenForm.DXDrawMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  Hint:=IntToStr(X)+':'+IntToStr(Y);
end;

procedure TScreenForm.FormPaint(Sender: TObject);
begin
//  if not bDrawRegion then
//    SetRegion;
end;

procedure TScreenForm.SetViewport(Handle: THandle; Bitmap: TBitmap);
var
  Bmp:TBitmap;
  rgn:Longint;
begin
  rgn:=CreateBitmapRgn(Bitmap,clBlack);
  SelectObject(Handle,rgn);
//  BitBlt(Handle,0,0,200,200,Bitmap.Canvas.Handle,0,0,Srccopy);
end;

procedure TScreenForm.ApplicationEvents1Exception(Sender: TObject;
  E: Exception);
begin
  ShowMessage(E.Message);
end;

procedure TScreenForm.btnStartClick(Sender: TObject);
begin
  GripGame.Restart;
end;

procedure TScreenForm.btnStopClick(Sender: TObject);
begin
  GripGame.Stop;
end;

procedure TScreenForm.Button3Click(Sender: TObject);
begin
  if not bDrawRegion then
    SetRegion;
end;

procedure TScreenForm.Button4Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TScreenForm.Button2Click(Sender: TObject);
begin
  GripGame.Resume;
end;

procedure TScreenForm.TrackBar1Change(Sender: TObject);
begin
  Datas.MidiPlayer.TempoPercent:=TrackBar1.Position;
end;

procedure TScreenForm.Button5Click(Sender: TObject);
begin
  datas.show;
end;

procedure TScreenForm.CheckBox1Click(Sender: TObject);
begin
  StressOne.EasyMode:=CheckBox1.Checked;
end;

end.
