unit uSynergy;

interface

uses SysUtils, Classes,cmpMidiPlayer,uDatas,forms;

type
  {1 midiΥX{y }
  TSynergy = class (TObject)
  public
    procedure Pause; virtual;
    procedure Play; virtual;
    procedure Stop; virtual;
  end;
  
  {1 midi }
  TRocker = class (TSynergy)
  private
    FSpeed: Integer;
  public
    procedure Play; override;
    procedure Stop; override;
    property Speed: Integer read FSpeed write FSpeed;
  end;
  
  {1 X@tCy }
  TBrood = class (TSynergy)
  end;

  {1 ѪRyX{ }
  TMetronome = class (TSynergy)
  private
    FCursor: Integer;
    FPrizeList: TStrings;
    FSpread: TBits;
    FNoteList:array of Integer;
    procedure DoDecompose;
    function GetCount: Integer;
  public
    constructor Create;
    procedure GetNextPos(var bar,beat,tick:Integer);
    function IsMatchBar(bar,beat,tick:Integer): Integer;
    function GetNoteString(Index:Integer):String;
    procedure ReadPrizeList(FileName:string);
    property Spread: TBits read FSpread;
    property Count:Integer read GetCount;
  end;
  

implementation

uses uGlobal,uUtility;

{
*********************************** TSynergy ***********************************
}
procedure TSynergy.Pause;
begin
end;

procedure TSynergy.Play;
begin
end;

procedure TSynergy.Stop;
begin
end;

{
*********************************** TRocker ************************************
}
procedure TRocker.Play;
begin
  inherited Play;
  
  Datas.MidiPlayer.Play:=True;
end;

procedure TRocker.Stop;
begin
  inherited Stop;

  Datas.MidiPlayer.Play:=False;
end;

{
********************************** TMetronome **********************************
}
constructor TMetronome.Create;
begin
  inherited;
  FSpread:=TBits.Create;
end;

procedure TMetronome.DoDecompose;
var
  bar, beat, tick,kind: Integer;
  s: string;
  measure: Integer;
  i: Integer;
begin
  s:=FPrizeList.Strings[FPrizeList.count-1];
  SplitToBarPos(s,bar,beat,tick,kind);
  measure:=(bar+1)*4*100;
  FSpread.Size:=measure;
  SetLength(FNoteList,measure+1);
  for i:=0 to FPrizeList.Count-1 do
  begin
    s:=FPrizeList.Strings[i];
    SplitToBarPos(s,bar,beat,tick,kind);
    measure:=(bar*4+beat)*100+(tick div 25)*25;
    FSpread.Bits[measure]:=True;
    FNoteList[measure]:=Kind;
  end;
end;

function TMetronome.GetCount: Integer;
begin
  Result:=FPrizeList.Count;
end;

procedure TMetronome.GetNextPos(var bar,beat,tick:Integer);
var
  s: string;
begin
{  Inc(FCursor);
  s:=FPrizeList.Strings[FCursor];
  SplitToBarPos(s,bar,beat,tick);  }
end;

function TMetronome.GetNoteString(Index: Integer): String;
begin
  Result:=FPrizeList.Strings[Index];
end;

function TMetronome.IsMatchBar(bar,beat,tick:Integer): Integer;
var
  _bar, _beat, _tick: Integer;
  s: string;
  i: Integer;
begin
{  Result:=-1;
  for i:=0 to FPrizeList.Count-1 do
  begin
    s:=FPrizeList.Strings[i];
    SplitToBarPos(s,_bar,_beat,_tick);
    if (bar=_bar) and (beat=_beat) then
    begin
      Result:=i;
      break;
    end;
  end; }
end;

procedure TMetronome.ReadPrizeList(FileName:string);
begin
  //if assigned(FPrizeList) then FPrizeList.Free;
  FPrizeList:=TStringList.Create;
  FPrizeList.LoadFromFile(AppPath+FileName);
  FCursor:=0;
  DoDecompose;
end;



end.
